//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#ifndef CALL_TREE_OUTPUT_H
#define CALL_TREE_OUTPUT_H

#include "ParseOutput.h"

#include <map>
#include <set>
#include <string>
#include <fstream>

class Namespace;
class Function;

class CallTreeOutput : public ParseOutput
{
 public:
    typedef std::set<Function *> CallerSet;

    CallTreeOutput(Namespace& ns)
	: _namespace(ns)
	{}

    virtual void functionCall(const std::string& caller,
			      const std::string& callee, bool callThru,
			      const std::string& t);

    void writeCallGraph(std::ofstream& out, Function *f) const;
    unsigned int nCallers(Function *f) { return _callers[f].size(); }

    const CallerSet& callers(Function *f) { return _callers[f]; }

 private:
//    struct CallInfo {
//	Function *call;
//	Function *caller;
//
//	CallInfo(Function *call_, Function *caller_)
//	    : call(call_), caller(caller_)
//	    {};
//    };
    typedef std::map<Function *, CallerSet > CallerMap;

    Namespace& _namespace;
    CallerMap _callers;

    std::string getString(Function *f);
};

#endif // CALL_TREE_OUTPUT_H
