//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#ifndef COUNTER_H
#define COUNTER_H

// Used for convience with std::map<hash, int> so that you can just
// do map[hash]++ without worrying about whether it exists.
class Counter {
 public:
    Counter() : _val(0) {};
    int& operator++() { _val += 1;  return _val; }  // prefix
    int operator++(int) { _val += 1;  return _val; } // postfix
    operator int& () { return _val; };
    bool operator< (const Counter& that) const
	{ return (this->_val < that._val); }
    bool operator== (const Counter& that) const
	{ return (this->_val == that._val); }
    bool operator!= (const Counter& that) const
	{ return (this->_val != that._val); }
 private:
    int _val;
};

#endif // COUNTER_H
