//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#include "Function.h"
#include "Namespace.h"

using namespace std;

string Function::mangledName() const
{
    string n = string("f_") + name();
    for (vector<Arg>::const_iterator it = _args.begin();  it != _args.end();  ++it) {
	if (it == _args.begin())
	    n += "_";
	n += it->type;
    }
    return n;
}

string Function::anchor() const
{
    return owningClass()->name() + string(".") + name() + string("-func");
}

Function* Function::getAncestor(Namespace& ns)
{
    if (!(modifiers() & Member::kVirtual))
	return this;

    const Class::NameArray parents = owningClass()->parents();
    Class::NameArray::const_iterator it;
    for (it = parents.begin();  it != parents.end();  ++it) {
	Class& parent = ns.get(*it);
	vector<Member *> members;
	if (parent.members_const().find(this->name(), &members)) {
	    for (unsigned int i = 0;  i < members.size();  ++i) {
		if (members[i]->symbolType() == Member::kFunction &&
		    ((Function*)members[i])->mangledName() == this->mangledName())
		    return ((Function *)members[i])->getAncestor(ns);
	    }
	}
    }
    return this;
}
