//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#ifndef GLOBAL_H
#define GLOBAL_H

#include <string>

typedef std::string Name;

struct Settings {
    bool debug;
    int minEdges;
    bool noEndOrStartNodes;
    bool onlyShowCycles;
    bool showHierarchy;
    bool showUndefinedClasses;
    std::string title;
    int tabSize;
};
extern Settings gSettings;

struct ParseState
{
    std::string file;
    int lineNo;  // line number of the beginning of this statement
    int actualLineNo;  // Last line read in from file
};
extern ParseState gParseState;

class Class;
class Member;
class Namespace;

std::string makePrettyName(const std::string& name);
std::string html(const std::string& str);
std::string getClassLink(const Class& c);
std::string getClassLink(const Class& c, const std::string& htmlText);
std::string getMemberLink(Namespace& ns, const Member *m, bool switchClass);
std::string getMemberLink(Namespace& ns, const Member *m, bool switchClass,
			  const std::string& htmlText,
			  const std::string& cssClass = "");

#endif // GLOBAL_H
