//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#include "Member.h"
#include "Class.h"

using namespace std;

string Member::mangledName() const
{
    return string("m_") + name();
}

string Member::anchor() const
{
    return owningClass()->name() + string(".") + name() + string("-var");
}

int Member::parseModifier(const std::string& token)
{
    if (token == "static")
	return kStatic;
    if (token == "virtual")
	return kVirtual;
    if (token == "abstract")
	return kPureVirtual;
    if (token == "final")
	return kFinal;
    if (token == "public")
	return kPublic;
    if (token == "protected")
	return kProtected;
    if (token == "private")
	return kPrivate;

    return 0;
}
