//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#include "Name2Type.h"

#include <iostream>

using namespace std;

const Name* Name2Type::find(const Name& name) const
{
    NameMap::const_iterator it = _name2Type.find(name);
    if (it != _name2Type.end())
	return &it->second;
    return NULL;
}

void Name2Type::printDot(const std::string& myClass) const
{
    int n = 0;
    NameMap::const_iterator it;
    for (it = _name2Type.begin();  it != _name2Type.end();  ++it) {
	if (_used.find(it->first) != _used.end()) {
	    if (n++ == 0)
		cout << "      ";
	    else
		cout << " -> ";
	    cout << "\"" << myClass << "." << it->first << "\"";
	}
    }
    if (n > 0)
	cout << " [color=\".1 .1 .1\"]" << endl;
}

void Name2Type::print() const
{
    NameMap::const_iterator it;
    for (it = _name2Type.begin();  it != _name2Type.end();  ++it)
	cerr << "   " << it->first << " -> " << it->second << endl;
}
