//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#ifndef NAME2TYPE_H
#define NAME2TYPE_H

#include "Global.h"
#include "Member.h"

#include <set>
#include <map>
/*
class Type {
 public:
    enum TypeInfo { kInvalid = 0, kObject = 1 };
    Type() : _info(kInvalid) {};
    Type(const std::string& type) : _type(type), _info(kObject) {};
    const std::string& type() const { return _type; }
    bool isValid() const { return _info != kInvalid; }

 private:
    std::string _type;
    TypeInfo _info;
};
*/
class Name2Type {
 public:
    typedef std::map<Name, Name> NameMap;
//    void add(Member *symbol) { _name2Type[symbol->name()] = symbol; }
    void add(const Name& name, const Name& type) { _name2Type[name] = type; }
    const Name* find(const Name& name) const;

    void markUsed(const Name& name) { _used.insert(name); }
    bool hasUsedMethods() const { return !_used.empty(); }
    unsigned int nUsedMethods() const { return _used.size(); }

    void printDot(const std::string& myClass) const;
    void print() const;
/*
    class iterator
    {
     public:
	iterator() {};
	iterator(Name2TypeMap::iterator it) : _it(it) {}
	Class& operator*() { return _it->second; }
	Class* operator->() { return &_it->second; }
	bool operator!=(const iterator& that) { return this->_it != that._it; }
	iterator operator++() { _it++;  return *this; }
	iterator& operator++(int) { _it++;  return *this; }
	const Name& key() { return _it->first; }
     private:
	Name2TypeMap::iterator _it;
    };
    iterator begin() { return iterator(_name2Type.begin()); }
    iterator end() { return iterator(_name2Type.end()); }
*/
    typedef NameMap::iterator iterator;
    iterator begin() { return _name2Type.begin(); }
    iterator end() { return _name2Type.end(); }

 private:
    NameMap _name2Type;
    std::set<Name> _used;
};

#endif // NAME2TYPE_H
