//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#ifndef PARSE_OUTPUT_H
#define PARSE_OUTPUT_H

#include <string>

class Symbol;
class Class;

class ParseOutput
{
 public:
    virtual ~ParseOutput() {};
    virtual void start() {};
    virtual void keywordToken(const std::string& t) {};
    virtual void builtinTypeToken(const std::string& t) {};
    virtual void objectToken(const std::string& t, Symbol *symbol) {};
    virtual void classToken(const Class* c, const std::string& t) {};
    virtual void stringToken(const std::string& t) {};
    virtual void whitespaceToken(const std::string& t) {};
    virtual void commentToken(const std::string& t) {};
    virtual void otherToken(const std::string& t) {};
    virtual void operatorToken(const std::string& t) {};
    virtual void functionDefinition(const std::string& className,
				    const std::string& functionName) {};
    virtual void functionCall(const std::string& caller,
			      const std::string& callee, bool callThru,
			      const std::string& t) {};
    virtual void objectDefinition(const std::string& className,
                                  const std::string& objectName) {};
};

#endif // PARSE_OUTPUT_H
