//-------------------- Copyright (C) 2009 by Geoffrey Prewett -----------------
#include "Symbol.h"
#include <assert.h>

using namespace std;

void Symbol::setName(const Name& name)
{
    assert(_name.empty());
    _name = name;
}

void Symbol::setDefinition(const std::string& file, int line)
{
    _definedInFile = file;
    _definedAtLine = line;
    _sourceFile = file;
    
    if (_sourceFile[0] == '/')
	_sourceFile.erase(0, 1);
    string::size_type pos;
    while((pos = _sourceFile.find("../")) != string::npos)
	_sourceFile.replace(pos, 3, "");
    while((pos = _sourceFile.find("./")) != string::npos)
	_sourceFile.replace(pos, 2, "");
    if (_sourceFile[0] == '.')
	_sourceFile.replace(0, 1, "_");

    while((pos = _sourceFile.find("/")) != string::npos)
	_sourceFile.replace(pos, 1, "_");
}

string Symbol::definitionHref() const
{
    return sourceFilename() + string("#") + anchor();
}
